package com.liang.controller;

import com.liang.common.annotation.LogAround;
import com.liang.entity.BaseRequestcode;
import com.liang.service.BaseRequestcodeService;
import io.swagger.annotations.ApiOperation;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * (BaseRequestcode)表控制层
 *
 * @author makejava
 * @since 2023-03-03 22:31:21
 */
@Controller
@RequestMapping("baseRequestcode")
public class BaseRequestcodeController {
    /**
     * 服务对象
     */
    @Resource
    private BaseRequestcodeService baseRequestcodeService;

    /**
     * 分页查询
     *
     * @param baseRequestcode 筛选条件
     * @param pageRequest     分页对象
     * @return 查询结果
     */
    @GetMapping
    public ResponseEntity<Page<BaseRequestcode>> queryByPage(BaseRequestcode baseRequestcode, PageRequest pageRequest) {
        return ResponseEntity.ok(this.baseRequestcodeService.queryByPage(baseRequestcode, pageRequest));
    }

    /**
     * 通过主键查询单条数据
     *
     * @param id 主键
     * @return 单条数据
     */
    @GetMapping("{id}")
    public ResponseEntity<BaseRequestcode> queryById(@PathVariable("id") Object id) {
        return ResponseEntity.ok(this.baseRequestcodeService.queryById(id));
    }

    /**
     * 新增数据
     *
     * @param baseRequestcode 实体
     * @return 新增结果
     */
    @PostMapping
    public ResponseEntity<BaseRequestcode> add(BaseRequestcode baseRequestcode) {
        return ResponseEntity.ok(this.baseRequestcodeService.insert(baseRequestcode));
    }

    /**
     * 编辑数据
     *
     * @param baseRequestcode 实体
     * @return 编辑结果
     */
    @PutMapping
    public ResponseEntity<BaseRequestcode> edit(BaseRequestcode baseRequestcode) {
        return ResponseEntity.ok(this.baseRequestcodeService.update(baseRequestcode));
    }

    /**
     * 删除数据
     *
     * @param id 主键
     * @return 删除是否成功
     */
    @DeleteMapping
    public ResponseEntity<Boolean> deleteById(Object id) {
        return ResponseEntity.ok(this.baseRequestcodeService.deleteById(id));
    }

    @ApiOperation(value = "页面初始化", notes = "页面初始化")
    @RequestMapping(value = "/init", method = RequestMethod.GET)
    public String init() {
        return "baserequestcode/list";
    }

    @LogAround("数据分页查询")
    @ApiOperation(value = "数据分页查询", notes = "数据分页查询")
    @ResponseBody
    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public Object list() {

        List<BaseRequestcode> list = baseRequestcodeService.queryAll();

        Map<String, Object> resultMap = new HashMap<>();
        resultMap.put("code", 0);
        resultMap.put("msg", "");
        resultMap.put("count", list.size());
        resultMap.put("data", list);

        return resultMap;
    }
}

